local mods = {
'vanilla','vanilla_enemies','5dimores','alienwall','allminable','andrew','angelsores','anonymods','beyond','bioindustries','bobenemies','bobores','bukket','clownsores','cncssulfur','darkmatter','darkstar','deepores','dp77ores','dp77sulfur','druglab','dytech','dyworld','engineers','evolution','finitewater','fmrx','fpp','groundsulfur','hardcrafting','homeworld','hydraulicpumpjacks','iceore','infinium','kpot','liquidscience','mutabor','napus','narmod','naturalgas','omnimatter','peacemod','portalresearch','primordialooze','pycoal','pyfusion','pyhightech','reactor','replicators','roadworks','senpais','sigmaonenuclear','springwater','sulfuricacid','sulfurmod','thunderstone','uraniumpower','xander','yaiom','yuoki_industries'
}

local function get_fillers(root) --procedurally extracts all the filler functions
  -- remember current global functions
  local global_names = {}
  for name,_ in pairs(_G) do global_names[name] = true end
  -- load each mods "fillConfig" function into global scope...
  for _,mod in pairs(mods) do require (root ..'example_configs_1/'..mod) end
  -- purge filler functions from global scope...
  local fillers = {}
  for name,_ in pairs(_G) do
    if not global_names[name] then
      fillers[name] = _G[name]
      _G[name] = nil
      end
    end
  return fillers
  end
  
return function (root) --merges all mod configs into one giant config table
  local configs = {}
  local fillers = get_fillers(root)
  
  for name,func in pairs(fillers) do
    func(configs)
    -- local conf = {}
    -- func(conf)
    -- configs[name] = conf
    end
    -- if estring .find_sub(name,'fill') then
      -- print(name)
      -- end
    -- end
    
  -- print(serpent.block(configs))
    
  return configs
  end
  
  
